<?xml version="1.0" encoding="UTF-8"?>
<!--

        This file is part of the Squashtest platform.
        Copyright (C) Henix, henix.fr

        See the NOTICE file distributed with this work for additional
        information regarding copyright ownership.

        This is free software: you can redistribute it and/or modify
        it under the terms of the GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        this software is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public License
        along with this software.  If not, see <http://www.gnu.org/licenses/>.

-->
<config
  xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'
  xmlns='http://www.ehcache.org/v3'
  xsi:schemaLocation="http://www.ehcache.org/v3 http://www.ehcache.org/schema/ehcache-core-3.1.xsd">


  <!-- acl cache for spring security (lookup strategy, user details manager etc) -->
  <cache alias="aclCache">

    <!--
    It turns out that spring cache plumbing forbids us to declare the types of the
    key/values in the cache (see Eh107CacheManager#getCache(String)
    So I leave it here as documentation but it should stay commented out.

    <key-type>java.io.Serializable</key-type>
    <value-type>org.springframework.security.acls.model.MutableAcl</value-type>
    -->
    <expiry>
      <tti>600</tti>
    </expiry>
    <!--
	This cache should not overflow on disk so we configure heap only
	The size here should be enough for 500 users
	(ie 500 * 6, 6 being the size of table ACL_CLASS)
	-->
    <heap>3000</heap>
  </cache>

  <cache-template name="admin-cache-template">
    <expiry>
      <none/>
    </expiry>
    <heap>5000</heap>

  </cache-template>

  <cache alias="org.squashtest.tm.domain.project.Project" uses-template="admin-cache-template"/>
  <cache alias="org.squashtest.tm.domain.bugtracker.domain.BugTracker" uses-template="admin-cache-template"/>
  <cache alias="org.squashtest.tm.domain.aiserver.AiServer" uses-template="admin-cache-template"/>
  <cache alias="org.squashtest.tm.domain.testautomation.TestAutomationServer" uses-template="admin-cache-template"/>

</config>
